package com.youjiayun.demo.entity.common;


/**
 * @Author 涛涛
 * @Desc  api请求返回状态码和说明信息
 * @Date 2021-12-02 10:07 上午
 */
public enum ResultApiExportCode {

    /*
    请求返回状态码和说明信息
     */
    SUCCESS(200, "成功"),
    MERCHANT_AGREEMENT_ERROR(2001, "商户编号或协议编码错误"),
    ERROR_PARAM(2002, "参数异常"),
    RESOURCE_ERROR(2003, "系统异常"),
    DATA_ERROR(2004, "数据异常"),
    REQUEST_ERROR(2005, "请求失败"),
    WHITELIST_ERROR(2006, "IP白名单不存在"),
    REQUEST_ORDER_ID_ERROR(2007, "请勿重复请求"),
    APP_KEY_ERROR(2008, "密钥错误"),
    SIGN_KEY_ERROR(2009, "签名比对错误"),
    AUTH_REAL_NAME_FAIL(2010, "用户姓名与身份证不一致"),
    AUTH_REQUEST_ERROR(2011, "实名验证失败"),
    SIGN_EXIST_ERROR(2012, "用户已签约"),

    BAD_REQUEST(4000, "参数或者语法不对"),
    SERVER_ERROR(5000, "服务器内部错误"),


    API_PAY_REPEAT_ORDER_ERROE(6000,"该笔订单已存在，请勿重复处理"),
    API_PAY_AMOUNT_LIMIT_ORDER_ERROE(6001,"单笔打款限制最低1元"),
    API_PAY_STAFF_NO_ERROE(6002,"人员不存在"),
    API_PAY_STAFF_NO_SIGN_ERROE(6003,"人员未签约"),
    API_PAY_PAYEE_CHANL_TYPE_ERROE(6004,"收款渠道类型错误"),
    API_PAY_STAFF_AUTH_ERROE(6005,"身份信息不一致"),
    API_PAY_TAX_LIMIT_ORDER_ERROE(6006,"超出业务开展地月累计收益限额"),
    API_PAY_GET_ORDER_ERROE(6007,"查无此单"),
    API_PAY_BANK_LIMIT_ERROE(6008,"因银行原因，晚间23:00-凌晨02:00期间不可打款"),
    API_PAY_MERCHANT_ACCOUNT_ERROE(6009,"该商户还未开户，请联系管理员进行开户！"),
    API_PAY_INSUFFICIENT_BALANCE_ERROE(6010,"余额不足，暂无法发放"),
    API_PAY_BALANCE_GET_ERROE(6011,"查询余额失败"),
    API_PAY_CHANL_LIMIT_AMOUNT_ERROE(6012,"超过通道限额"),




    ;

    private final int code;
    private final String msg;

    ResultApiExportCode(int code, String msg) {
        this.code = code;
        this.msg = msg;
    }

    public int getCode() {
        return code;
    }

    public String getMsg() {
        return msg;
    }

}
