package com.youjiayun.demo.util;

import com.alibaba.fastjson.JSONObject;
import com.youjiayun.demo.entity.request.SignApiGetRequestDTO;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import com.youjiayun.demo.entity.request.PayApiExportRequestDTO;
import com.youjiayun.demo.entity.request.SignApiExportRequestDTO;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.MediaType;
import org.springframework.http.ResponseEntity;
import org.springframework.web.client.RestTemplate;

import java.math.BigDecimal;
import java.security.MessageDigest;
import java.util.Map;
import java.util.TreeMap;

/**
 * @Author 涛涛
 * @Desc   签名加密工具类
 * @Date 2021-12-03 6:19 下午
 */
public class SignEncryUtil {

    private static Logger logger = LoggerFactory.getLogger(SignEncryUtil.class);

    private static String[] hexDigits = {"0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "a", "b", "c", "d", "e", "f"};

    @Autowired
    private RestTemplate restTemplate;


    public static void main(String[] args) {
        String serct = "qVTuorCj4JZBHz7tH0HlP68LXWtwOyPAMAz9jk";
        String name ="张三";
        String idCard ="51078119931131318";
        String mobile ="1999999938";
        SignApiExportRequestDTO signApiExportRequestDTO = new SignApiExportRequestDTO();
        signApiExportRequestDTO.setIdCard(idCard);
        signApiExportRequestDTO.setName(name);
        signApiExportRequestDTO.setMobile(mobile);

        PayApiExportRequestDTO payApiExportRequestDTO = new PayApiExportRequestDTO();
        payApiExportRequestDTO.setName(name);
        payApiExportRequestDTO.setIdCard(idCard);
        payApiExportRequestDTO.setOrderNo("323233223");
        payApiExportRequestDTO.setCollAccountNo("323233223");
        payApiExportRequestDTO.setAmount(BigDecimal.ONE);
        TreeMap map = JSONObject.parseObject(JSONObject.toJSONString(payApiExportRequestDTO), TreeMap.class);
        String s = encrySignGet(serct, new SignApiGetRequestDTO("916652101180850176"));
        System.out.println(JSONObject.toJSON(signApiExportRequestDTO));
        System.out.println(s);
    }


    public static String encrySignGet(String secretKey, Object object) {
        StringBuilder stringBuilder = new StringBuilder();
        stringBuilder.append(secretKey);
        stringBuilder.append(JSONObject.toJSONString(object));
        String md5Value = md5(stringBuilder.toString());
        logger.info("===========encrySign:{}============",md5Value);
        return md5Value;
    }

    public static String encrySignPost(String secretKey, Object object) {
        TreeMap<String, String> treeMap = JSONObject.parseObject(JSONObject.toJSONString(object), TreeMap.class);
        StringBuilder stringBuilder = new StringBuilder();
        stringBuilder.append(secretKey);
        for (Map.Entry entry : treeMap.entrySet()) {
            stringBuilder.append(entry.getValue());
        }

        String md5Value = md5(stringBuilder.toString());
        logger.info("===========encrySign:{}============",md5Value);
        return md5Value;
    }

    public static String md5(String data)  {
        if(StringUtils.isBlank(data)){
            return "";
        }
        try {
            MessageDigest md5 = MessageDigest.getInstance("MD5");
            byte[] b = data.getBytes("UTF8");
            md5.update(b, 0, b.length);
            return byteArrayToHexString(md5.digest());
        } catch (Exception e) {
            logger.error("md5 error", e);
        }
        return "";
    }


    private static String byteArrayToHexString(byte[] b) {
        StringBuilder sb = new StringBuilder();
        for (byte bt : b) sb.append(byteToHexString(bt));
        return sb.toString();
    }


    private static String byteToHexString(byte b) {
        int n = b;
        if (n < 0) {
            n = 256 + n;
        }
        int d1 = n / 16;
        int d2 = n % 16;
        return hexDigits[d1] + hexDigits[d2];
    }
}
