<?php


if (!defined('IN_IA')) {
    exit('Access Denied');
}

class Youjiayun_EweiShopV2Model
{
    public $appKey;
    public $secretKey;
    public $merchantNo;
    public $agreementId;
    public $url;

    public function __construct()
    {
        //友加云提供
        $this->appKey = '';
        $this->secretKey = '';
        $this->merchantNo = '';
        $this->agreementId = '';
        //沙箱环境
        $this->url = 'https://yunshang-api-test.youjiayun.com';
        //正式环境
//        $this->url = 'https://yunshang-api.youjiayun.com';
    }

    //签约接口
    public function sign($data)
    {
        $url = $this->url . '/merchant/exportApi/sign/sign';
        $sign = $this->encrypt($data);
        $res = $this->curl_post($url, $data, $sign);
        return $res;
    }

    //签约接口
    public function noSign($data)
    {
        $url = $this->url . '/merchant/exportApi/sign/noSign';
        $sign = $this->encrypt($data);
        $res = $this->curl_post($url, $data, $sign);
        return $res;
    }

    //委托代征支付宝发放API
    public function aLiPayApi($data)
    {
        $url = $this->url . '/merchant/exportApi/pay/aLiPayApi';
        $sign = $this->encrypt($data);
        $res = $this->curl_post($url, $data, $sign);
        return $res;
    }

    //委托代征银行卡发放API
    public function bankPayApi($data)
    {
        $url = $this->url . '/merchant/exportApi/pay/bankPayApi';
        $sign = $this->encrypt($data);
        $res = $this->curl_post($url, $data, $sign);
        return $res;
    }

    //余额查询
    public function getBalanceApi($data)
    {
        $url = $this->url . '/merchant/exportApi/pay/getBalanceApi?bankType=' . $data['bankType'];
        $sign = $this->encryptGet($data);
        $res = $this->curl_get($url, $data, $sign);
        return $res;
    }

    public function curl_get($url, $data, $sign)
    {
        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($curl, CURLOPT_HEADER, 0);
        curl_setopt($curl, CURLOPT_HTTPHEADER,
            array(
                'Content-Length:' . strlen($data),
                'orderId:' . time(),
                'merchantNo:' . $this->merchantNo,
                'agreementId:' . $this->agreementId,
                'sign:' . $sign,
                'appKey:' . $this->appKey,
                'requireTime:' . date("Y-m-d H:i:s")
            )
        );
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        $res = curl_exec($curl);
        $errorno = curl_errno($curl);
        $info = curl_getinfo($curl);

        if ($errorno) {
            return array('errorno' => false, 'errmsg' => $errorno);
        }
        curl_close($curl);
        return $res;
    }

    public function curl_post($url, $data, $sign)
    {

        $curl = curl_init();
        curl_setopt($curl, CURLOPT_URL, $url);
        curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
        if (!empty($data)) {
            $data = json_encode($data);
            curl_setopt($curl, CURLOPT_POST, 1);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
            curl_setopt($curl, CURLOPT_HEADER, 0);
            curl_setopt($curl, CURLOPT_HTTPHEADER,
                array(
                    'Content-Type: application/json; charset=utf-8',
                    'Content-Length:' . strlen($data),
                    'orderId:' . time(),
                    'merchantNo:' . $this->merchantNo,
                    'agreementId:' . $this->agreementId,
                    'sign:' . $sign,
                    'appKey:' . $this->appKey,
                    'requireTime:' . date("Y-m-d H:i:s")
                )
            );
        }
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
        $res = curl_exec($curl);
        $errorno = curl_errno($curl);
        if ($errorno) {
            return array('errorno' => false, 'errmsg' => $errorno);
        }
        curl_close($curl);
        return $res;
    }

    public function encrypt($data)
    {
        ksort($data);
        $str = $this->secretKey;
        foreach ($data as $k => $v) {
            $str .= $v;
        }
        $sign = md5($str);
        return $sign;
    }

    public function encryptGet($data)
    {
        $str = $this->secretKey;
        $str .= json_encode($data);
        $sign = md5($str);
        return $sign;
    }
}